// Author: Vladimir Savic
// E-mail: vladimirsvc@yahoo.com

#include "TimerState.h"

static StateAbstract* ptr;
extern DC_MOTOR_DATA_TYPE DCMotor;

// **********************************
// * Timer State: initialization method *
// **********************************
void TimerStateInitialization (void* ptrSa){
     ptr = (StateAbstract*)ptrSa;
                        //    DT PS CMD
                        // 11 00 01 02
     ptr->Flags = 0xC6; // 11 00 01 10 binary
     
     ptr->DefaultStateMethod = &TimerStateMethod;
}

// *******************************
// * Timer State: default method *
// *******************************
static void TimerStateMethod( void* command ){
    // regulation of time slice depends on external command
    if(*((BYTE*)command) == 0x03 && DCMotor.TimeSlice > 10){           // todo: 10 as config parameter!
        DCMotor.TimeSlice -= 10;
    }
    else
    if(*((BYTE*)command) == 0x04 && DCMotor.TimeSlice < 1000){         // todo: 1000 as config parameter!
        DCMotor.TimeSlice += 10;
    }

    Vdelay_ms(DCMotor.TimeSlice);                                      // broken portability !!! - todo: remove this code to extern file, place interface for timer libs
}